
#include <tchar.h>

#include <Windows.h>

#include "Dumpper.hpp"


const BYTE ASCII[] =
{
	_T('.'), _T('.'), _T('.'), _T('.'), _T('.'), _T('.'), _T('.'), _T('.'),
	_T('.'), _T('.'), _T('.'), _T('.'), _T('.'), _T('.'), _T('.'), _T('.'),

	_T('.'), _T('.'), _T('.'), _T('.'), _T('.'), _T('.'), _T('.'), _T('.'),
	_T('.'), _T('.'), _T('.'), _T('.'), _T('.'), _T('.'), _T('.'), _T('.'),

	_T(' '), _T('!'), _T('"'), _T('#'), _T('$'), _T('%'), _T('&'), _T('\''),
	_T('('), _T(')'), _T('*'), _T('+'), _T(','), _T('-'), _T('.'), _T('/'),

	_T('0'), _T('1'), _T('2'), _T('3'), _T('4'), _T('5'), _T('6'), _T('7'),
	_T('8'), _T('9'), _T(':'), _T(';'), _T('<'), _T('='), _T('>'), _T('?'),

	_T('@'), _T('A'), _T('B'), _T('C'), _T('D'), _T('E'), _T('F'), _T('G'),
	_T('H'), _T('I'), _T('J'), _T('K'), _T('L'), _T('M'), _T('N'), _T('O'),

	_T('P'), _T('Q'), _T('R'), _T('S'), _T('T'), _T('U'), _T('V'), _T('W'),
	_T('X'), _T('Y'), _T('Z'), _T('['), _T('\\'),_T(']'), _T('^'), _T('_'),

	_T('`'), _T('a'), _T('b'), _T('c'), _T('d'), _T('e'), _T('f'), _T('g'),
	_T('h'), _T('i'), _T('j'), _T('k'), _T('l'), _T('m'), _T('n'), _T('o'),

	_T('p'), _T('q'), _T('r'), _T('s'), _T('t'), _T('u'), _T('v'), _T('w'),
	_T('x'), _T('y'), _T('z'), _T('{'), _T('|'), _T('}'), _T('~'), _T('.'),
};

inline BYTE ToChar( INT_PTR nValue )
{
	if( nValue >= sizeof(ASCII) )
	{
		return (BYTE)_T('.');
	}

	return ASCII[nValue];
}

CDumpper::CDumpper() :
	m_lpszHex ( &m_szBuffer[0] ),
	m_lpszChar( &m_szBuffer[(LINE_NUM * FACTOR_LEN + ADD_SP)] )
{
	for( _TCHAR& c : m_szBuffer )
	{
		c = _T(' ');
	}

	m_szBuffer[ _countof(m_szBuffer) - 1 ] = _T('\0');

	m_nIndex = 0;

	m_lpfnDisplay = &CDumpper::DisplayFirst;

	m_offset.QuadPart = 0;
}

void CDumpper::BeginDisplay()
{
	m_nIndex = 0;

	m_lpfnDisplay = &CDumpper::DisplayFirst;
}

INT_PTR CDumpper::Display( BYTE const* lpBuffer, LARGE_INTEGER remaningLength )
{
	return (this->*m_lpfnDisplay)( lpBuffer, &remaningLength );
}

INT_PTR CDumpper::DisplayFirst( BYTE const* lpBuffer, LARGE_INTEGER* lpRemaningLength )
{
//	_tprintf_s( _T("00112233:44556677  00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F  0123456789ABCDEF\n") );
	_tprintf_s( _T("         AhX  00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F  0123456789ABCDEF\n") );

	INT_PTR nPosition = m_offset.LowPart & 0x0f;

	for( INT_PTR i = 0; i < nPosition; i ++ )
	{
//		_sntprintf_s( &m_lpszHex[FACTOR_LEN * i], (FACTOR_LEN + 1), _TRUNCATE, _T("   ") );
		m_lpszHex[FACTOR_LEN * i + 0] = _T(' ');
		m_lpszHex[FACTOR_LEN * i + 1] = _T(' ');
//		m_lpszHex[FACTOR_LEN * i + 2] = _T(' ');

		m_lpszChar[i] = _T(' ');
	}

#if 1

	m_nIndex = nPosition;

	m_lpfnDisplay = &CDumpper::DisplayNext;

	return DisplayNext( lpBuffer, lpRemaningLength );

#else

	_tprintf_s( _T("%08X:%08X "), m_offset.HighPart, m_offset.LowPart );

	INT_PTR nCount    = LINE_NUM - nPosition;

	if( (LONGLONG)nCount > lpRemaningLength->QuadPart )
	{
		nCount = (INT_PTR)lpRemaningLength->QuadPart;
	}

	for( INT_PTR i = nPosition; i < nPosition + nCount; i ++ )
	{
		_sntprintf_s( &m_lpszHex[FACTOR_LEN * i], (FACTOR_LEN + 1), _TRUNCATE, _T("%02x "), *lpBuffer );

		m_lpszChar[i] = ToChar( *lpBuffer );

		lpBuffer ++;
	}

	m_nIndex += nPosition + nCount;

	if( m_nIndex >= LINE_NUM || IsEmptyRemaning(nCount, lpRemaningLength) )
	{
		m_nIndex = 0;

		_tprintf_s( m_szBuffer );
	}

	m_lpfnDisplay = &CDumpper::DisplayNext;

	m_offset.QuadPart += nCount;

	return nCount;

#endif
}

INT_PTR CDumpper::DisplayNext( BYTE const* lpBuffer, LARGE_INTEGER* lpRemaningLength )
{
	// 񏑂ޗvfZo

	// ߂vf̍ő吔ɏ񂾗vf
	INT_PTR nCount = LINE_NUM - m_nIndex;

	// ޗvfƃobt@Ɋi[Ăc̗vfƂŏȂZo
	if( (LONGLONG)nCount > lpRemaningLength->QuadPart )
	{
		nCount = (INT_PTR)lpRemaningLength->QuadPart;
	}


	// o̓obt@ɗvf
	for( INT_PTR i = m_nIndex; i < m_nIndex + nCount; i ++ )
	{
//		_sntprintf_s( &m_lpszHex[FACTOR_LEN * i], (FACTOR_LEN + 1), _TRUNCATE, _T("%02x "), *lpBuffer );
		SetHexChar( FACTOR_LEN * i, *lpBuffer );

		m_lpszChar[i] = ToChar( *lpBuffer );

		lpBuffer ++;
	}

	// 񂾗vfXV
	m_nIndex += nCount;

	// ̂Âꂩ𖞂ꍇo
	//     sɏ߂ő吔ɒB
	//     wTCY
	if( m_nIndex >= LINE_NUM || IsEmptyRemaning(nCount, lpRemaningLength) )
	{
		// ItZbgAhX\
		_tprintf_s( _T("%08X:%08X  "), m_offset.HighPart, (m_offset.LowPart & 0xfffffff0) );

		m_offset.QuadPart += m_nIndex;

		m_nIndex = 0;

		m_lpszChar[-1] = _T(' ');

//		_tprintf_s( m_szBuffer );
		_putts( m_szBuffer );
	}

	return nCount;
}

void CDumpper::SetHexChar( INT_PTR nIndex, INT_PTR nValue )
{
	m_lpszHex[nIndex + 0] = (_TCHAR)HexChar( nValue >> 4 );

	m_lpszHex[nIndex + 1] = (_TCHAR)HexChar( nValue >> 0 );

//	m_lpszHex[nIndex + 2] = _T(' ');
}

BOOL CDumpper::IsEmptyRemaning( INT_PTR nCount, LARGE_INTEGER* lpRemaningLength )
{
	lpRemaningLength->QuadPart -= nCount;

	if( lpRemaningLength->QuadPart > 0 )
	{
		return FALSE;
	}

	for( INT_PTR i = m_nIndex; i < LINE_NUM; i ++ )
	{
//		_sntprintf_s( &m_lpszHex[FACTOR_LEN * i], (FACTOR_LEN + 1), _TRUNCATE, _T("   ") );
		m_lpszHex[FACTOR_LEN * i + 0] = _T(' ');
		m_lpszHex[FACTOR_LEN * i + 1] = _T(' ');
//		m_lpszHex[FACTOR_LEN * i + 2] = _T(' ');

		m_lpszChar[i] = _T(' ');
	}

	return TRUE;
}
